'use client';

import { useBroadcastChannel } from '@/app/_hooks/useBroadcastChannel';
import type { SiteBroadcastChannel } from '@/app/_types';
import { minutesToMilliseconds } from 'date-fns';
import { useSession } from 'next-auth/react';
import { enqueueSnackbar } from 'notistack';
import queryString from 'query-string';
import randomstring from 'randomstring';

/**
 * The `useUser` function is a custom hook that provides functionality for managing a user's account, including
 * generating a URL for account management, opening a window to manage the account, and updating the account.
 * @returns The `useUser` hook returns an object with two functions: `manageAccount` and `refreshAccount`.
 */
export const useUser = () => {
  const { data: session, update } = useSession();

  const { openAuxWindowChannel } = useBroadcastChannel();

  /**
   * The function `createdManageAccountUrl` generates a URL for account management with a redirect URI
   * that includes a code verifier.
   * @param {string} codeVerifier - The `codeVerifier` parameter is a radom string. It is typically generated by the client
   * application and used to verify the authenticity of the authorization code received from the authorization server.
   * @returns The function `createdManageAccountUrl` returns the `accountMangementUrl` value.
   */
  const createdManageAccountUrl = (codeVerifier: string) => {
    const accountMangement = session?.user.accountManagement;
    if (!accountMangement) return;

    let redirectUri: string | null = null;

    //redefine redirectUri with codeVerifier
    if (accountMangement.parts.referrer_uri) {
      redirectUri = queryString.stringifyUrl(
        {
          url: accountMangement.parts.referrer_uri,
          query: { codeVerifier },
        },
        { skipNull: true },
      );
    }

    //redefine accountMangementUrl with redirectUri
    const accountMangementUrl = queryString.stringifyUrl(
      {
        url: accountMangement.parts.baseUrl,
        query: {
          referrer: accountMangement.parts.referrer,
          referrer_uri: redirectUri,
        },
      },
      { skipNull: true },
    );

    return accountMangementUrl;
  };

  /**
   * The `manageAccount` function is responsible for opening a window to manage a user's account,
   * verifying the code verifier, handling response errors, and updating the account if successful.
   * @returns The function `manageAccount` returns a boolean value indicating whether the account was
   * successfully updated or not.
   */
  const manageAccount = async () => {
    const codeVerifier = randomstring.generate();
    const accountMangementUrl = createdManageAccountUrl(codeVerifier);
    if (!accountMangementUrl) return;

    const response = await openAuxWindowChannel<SiteBroadcastChannel.Message>(
      'keycloak-account-manager',
      accountMangementUrl,
      { timeout: minutesToMilliseconds(5) },
    ).catch((error: string) => {
      return { success: false, error: error } as SiteBroadcastChannel.Message;
    });

    if (codeVerifier !== response.codeVerifier) {
      return {
        success: false,
        error: 'error: codeVerifier invalid',
      } as SiteBroadcastChannel.Message;
    }

    if (!response.success) {
      if (response.error === 'timeout') return;
      const message = response.error ? response.error : 'Something whent wrong.';
      enqueueSnackbar(message, { variant: 'error' });
      return;
    }

    await update({ reason: 'accountUpdated' });
    enqueueSnackbar('Account updated');

    return response.success;
  };

  /**
   * The function `refreshAccount` updates the account and displays a notification.
   */
  const refreshAccount = async () => {
    await update({ reason: 'accountUpdated' });
    enqueueSnackbar('Account updated');
  };

  return {
    manageAccount,
    refreshAccount,
  };
};
